
package de.ivu.elect.presentation.benutzerverwaltung.menu;

import java.util.Arrays;
import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.benutzerverwaltung.entity.RechteKonfigurationMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.benutzerverwaltung.RechteTestmodusEditView;
import de.ivu.elect.presentation.benutzerverwaltung.exchange.RechteKonfigurationExportView;
import de.ivu.elect.presentation.benutzerverwaltung.exchange.RechteKonfigurationImportBestaetigenView;
import de.ivu.elect.presentation.benutzerverwaltung.exchange.RechteKonfigurationImportFormatFestlegenView;
import de.ivu.elect.presentation.benutzerverwaltung.exchange.RechteKonfigurationImportSearchView;
import de.ivu.elect.presentation.menu.AbstractMenuItemEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;

public class RechteTestmodusMenuItemEntry extends AbstractMenuItemEntry {

  private static final long serialVersionUID = 1L;

  @Inject
  private RechteTestmodusEditMenuItemEntry searchMenuItemEntry;

  @Inject
  private RechteKonfigurationMeta rechteKonfigurationMeta;

  protected UseCasePermission getUseCasePermission() {
    return searchMenuItemEntry.getUseCasePermission();
  }

  public String getTargetViewId() {
    return searchMenuItemEntry.getTargetViewId();
  }

  protected List<String> getAdditionalTopicViewIds() {
    return Arrays.asList(RechteTestmodusEditView.VIEW_ID, RechteKonfigurationImportSearchView.VIEW_ID,
        RechteKonfigurationImportFormatFestlegenView.VIEW_ID, RechteKonfigurationImportBestaetigenView.VIEW_ID,
        RechteKonfigurationExportView.VIEW_ID);
  }

  @Override
  protected String getLabel() {
    return searchMenuItemEntry.getLabel();
  }

  @Override
  public String getLabelKey() {
    return searchMenuItemEntry.getLabelKey();
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return AbstractGebietSecurity.KEINE_GEBIET_SECURITY;
  }

  @Override
  public boolean isRendered() {
    return hasUseCasePermission(getUseCasePermission());
  }

  @Override
  public boolean isDisabledInternal() {
    return false;
  }

  protected RechteKonfigurationMeta getMeta() {
    return rechteKonfigurationMeta;
  }

  public String getIcon() {
    return searchMenuItemEntry.getIcon();
  }
}